/*-----------------------------------------------------------------------
Nom du fichier: RBELEVE.h
Auteur: Philippe MARIANO

Projet: PPE Robot suiveur de ligne
Rle: Fichier d'en-tte de RB_ELEVE.c
Cr le: 18/02/2010
Dernire rvision le: 22/02/2011

Cross compilateur utilis: CodeVisionAVR
Composant cible : ATMEL 8 bits sur carte "Robot SISI"

Remarque: Ce fichier est destin  un projet CVAVR utilisant la carte SISI
Il doit tre plac dans  le rpertoire du projet
------------------------------------------------------------------------*/
#ifndef _RBELEVE_INCLUDED_
#define _RBELEVE_INCLUDED_

//************************************************************************************************************
// Prototype des fonctions "Elve" implmantes dans RB_ELEVE.c  (NE PAS MODIFIER)
//============================================================================================================
// Suivi de la ligne
//------------------------------------------------------------------------------------------------------------
void Mode_Run(void);
//------------------------------------------------------------------------------------------------------------
// Gestion de la balle
//------------------------------------------------------------------------------------------------------------
#if PARCOURS_ROBOT == AVEC_ARRET
void Gestion_Balle(void);
#endif
//************************************************************************************************************

//************************************************************************************************************
//  CONSTANTES
//============================================================================================================
// EtatCommandeMoteur : diffrents tats possibles pour la commande des moteurs   (NE PAS MODIFIER)
// -----------------------------------------------------------------------------------------------------------
#if FS12 == SOLUTIONELEVE
enum EtatCommandeMoteur {DEPART,CDE_CENTRE, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, 
CDE_DROITE_2PLUS, CDE_DROITE_3PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS, CDE_GAUCHE_2PLUS, CDE_GAUCHE_3PLUS,
CDE_GAUCHE_4PLUS, CDE_DROITE_4PLUS, CDE_COUPURE } ; 
#endif                 
// -----------------------------------------------------------------------------------------------------------
//============================================================================================================
/* ValeursCapteurLignePossibles : diffrentes positions du capteur par rapport  la ligne
// -----------------------------------------------------------------------------------------------------------
Infos: Dans l'numration ci-dessous, la valeur affecte au NOM d'une position dpend du sens de la
carte "Capteur Ligne" et de son cblage au Port x. Une cellule IR sur la ligne => bit correspondant = 1.
Une cellule IR hors ligne => bit correspondant = 0
                                                                 ^^^^^^^^^^^^^^^^  sens du dplacement du robot
                                                                |                |
                                                                |                |   
Exemple: Carte "Capteur Ligne" compose de 5 cellules IR Ux---> | U5 U4 U3 U2 U1 |  position des capteurs.
                                                                -----------------
    Avec     U1 reli  PA0
             U2 reli  PA1
             U3 reli  PA2
             U4 reli  PA3
             U5 reli  PA4

Si U4 et U5 sont hors ligne, le capteur a la position note GAUCHE_PLUS. La valeur renvoye
par le capteur est PAO = 1, PA1 = 1, PA2 = 1, PA3 = 0 et PA4 = 0 donc GAUCHE_PLUS = 1+2+4 = 7
------------------------------------------------------------------------------------------------------------*/
// Pour un capteur dont le connecteur est plac vers l'avant du robot, la table des valeurs est:
//------------------------------------------------------------------------------------------------------------
// MesureCapteurLignePossible  		Correspond  :
// 		    	   				    Hors_Ligne
// 		    					    Gauche3+
// 		     					    Gauche2+
//		    					    Centre1 (1 capteur IR sur la ligne)
// 		    					    Gauche+
//		    					    Centre3 (3 capteurs IR sur la ligne)
//		    					    Gauche
//		    					    Droite3+
//		    					    Droite2+
//		    					    Droite+
//		    					    Droite
// 		     					    Centre5 (5 capteurs IR sur la ligne)
//------------------------------------------------------------------------------------------------------------
// RAPPEL: LA PRISE EN COMPTE DE LA POSITION DU CAPTEUR LIGNE EST FAITE DANS RBxxx.h
#if FS11 == SOLUTIONELEVE || FS13 == SOLUTIONELEVE || FS12 == SOLUTIONELEVE
//------------------------------------------------------------------------------------------------------------
// Les valeurs ci-dessous sont renvoyes, si la mesure est correcte, par un capteur "LIGNE" positionn avec 
// son connecteur  l'AVANT par rapport au sens du dplacement du robot.
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! A COMPLETER PAR ELEVE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
#if  POSITIONCONNECTEUR == CONNECTEURAV
enum ValeursCapteurLignePossibles {HORS_LIGNE, GAUCHE_3PLUS, GAUCHE_2PLUS = ?, CENTRE_1, GAUCHE_PLUS=?,
CENTRE_3=?, GAUCHE, DROITE_3PLUS, DROITE_2PLUS=?, DROITE_PLUS=?, DROITE = 30, CENTRE_5};
//------------------------------------------------------------------------------------------------------------
// Les valeurs ci-dessous sont renvoyes, si la mesure est correcte, par un capteur "LIGNE" positionn avec son 
// connecteur  l'ARRIERE par rapport au sens du dplacement du robot. 
#elif POSITIONCONNECTEUR == CONNECTEURAR
enum ValeursCapteurLignePossibles {HORS_LIGNE, DROITE_3PLUS, DROITE_2PLUS = 3, CENTRE_1, DROITE_PLUS=7,
CENTRE_3=14, DROITE, GAUCHE_3PLUS, GAUCHE_2PLUS=24, GAUCHE_PLUS=28, GAUCHE = 30,CENTRE_5};
#endif
//------------------------------------------------------------------------------------------------------------
#endif
//------------------------------------------------------------------------------------------------------------ 
//============================================================================================================ 
// Mots de commande des Leds rouge. 
// ------------------------------------------------------------------------------------------------------------
#if FS13 == SOLUTIONELEVE || FS11 == SOLUTIONELEVE
//------------------------------------------------------------------------------------------------------------
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! A COMPLETER PAR ELEVE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//------------------------------------------------------------------------------------------------------------
#define Visu_Hors_ligne 	0b11111111
#define Visu_GAUCHE_3PLUS	0b11111110

// !!!!!!!!!!!!!!!!! Champ  renseigner  !!!!!!!!!!!!!!!!!

//============================================================================================================
#endif
//============================================================================================================
#endif
//************************************************************************************************************





